#include "OLED.h"
#include "oledfont.h"
#include "delay.h"

/*ʾƫ*/
uint8_t x_offset=0;

/**
 * @brief       ʼGPIO
 * @param       
 * @retval      
 */
void OLED_GPIOInit(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(OLED_SCK_GPIO_CLK|OLED_MOSI_GPIO_CLK|OLED_RES_GPIO_CLK|OLED_DC_GPIO_CLK|OLED_CS_GPIO_CLK,ENABLE);

    GPIO_InitStructure.GPIO_Pin=OLED_SCK_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(OLED_SCK_GPIO_PORT,&GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin=OLED_MOSI_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(OLED_MOSI_GPIO_PORT,&GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin=OLED_RES_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(OLED_RES_GPIO_PORT,&GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin=OLED_DC_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(OLED_DC_GPIO_PORT,&GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin=OLED_CS_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(OLED_CS_GPIO_PORT,&GPIO_InitStructure);
}

/**
 * @brief       OLEDʾеʼַֹ
 * @param       a:еʼַ
 * @param       b:еĽַ
 * @retval      
 */
void Column_Address(uint16_t a,uint16_t b)//еַ
{
    OLED_WR_REG(0x15);      // Set Column Address
    OLED_WR_REG(a+x_offset);
    OLED_WR_REG(b+x_offset);
}

/**
 * @brief       OLEDʾеʼַֹ
 * @param       a:еʼַ
 * @param       b:еʼַ
 * @retval      
 */
void Row_Address(uint16_t a,uint16_t b)
{
    OLED_WR_REG(0x75);      // Row Column Address
    OLED_WR_REG(a);
    OLED_WR_REG(b);
}

/**
 * @brief       OLED亯
 * @param       x1:еʼַ
 * @param       x2:еĽַ
 * @param       y1:еʼַ
 * @param       y2:еĽַ
 * @retval      
 */
void OLED_Fill(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint8_t color)
{
    uint8_t j,i;
    x1/=2;
    x2/=2;
    Column_Address(x1,x2-1);
    Row_Address(y1,y2-1);
    for(i=y1;i<y2;i++)
    {
        for(j=x1;j<x2;j++)
        {
            OLED_WR_DATA8(color);
        }
    }
}

/**
 * @brief       OLEDʾ
 * @param       x:еʼַ
 * @param       y:еʼַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowChinese(uint16_t x,uint16_t y,uint8_t *s,uint16_t sizey,uint8_t mode)
{
    while(*s!=0)
    {
        if(sizey==16) OLED_ShowChinese16x16(x,y,s,sizey,mode);
        else if(sizey==24) OLED_ShowChinese24x24(x,y,s,sizey,mode);
        else if(sizey==32) OLED_ShowChinese32x32(x,y,s,sizey,mode);
        else return;
        s+=2;
        x+=sizey;
    }
}

/**
 * @brief       OLEDʾ16ź
 * @param       x:еʼַ
 * @param       y:еʼַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */

void OLED_ShowChinese16x16(uint16_t x,uint16_t y,uint8_t *s,uint16_t sizey,uint8_t mode)
{
    uint8_t i,j,k,DATA=0,HZnum;
    uint8_t TypefaceNum;
    x/=2;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
    HZnum=sizeof(tfont16)/sizeof(typFNT_GB16);	//ͳƺֿĿ
    Column_Address(x,x+sizey/2-1);
    Row_Address(y,y+sizey-1);
    for(k=0;k<HZnum;k++)
    {
        if ((tfont16[k].Index[0]==*(s))&&(tfont16[k].Index[1]==*(s+1)))
        {
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<4;j++)
                {
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+0)))
                    {
                        DATA=0xf0;
                    }
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+1)))
                    {
                        DATA|=0x0f;
                    }
                    if(mode)
                    {
                        OLED_WR_DATA8(~DATA);
                    }
                    else
                    {
                        OLED_WR_DATA8(DATA);
                    }
                    DATA=0;
                }
            }
        }
    continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}

/**
 * @brief       OLEDʾ24ź
 * @param       x:еʼַ
 * @param       y:еʼַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowChinese24x24(uint16_t x,uint16_t y,uint8_t *s,uint16_t sizey,uint8_t mode)
{
    uint8_t i,j,k,DATA=0,HZnum;
    uint8_t TypefaceNum;
    x/=2;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
    HZnum=sizeof(tfont24)/sizeof(typFNT_GB24);	//ͳƺֿĿ
    Column_Address(x,x+sizey/2-1);
    Row_Address(y,y+sizey-1);
    for(k=0;k<HZnum;k++)
    {
        if ((tfont24[k].Index[0]==*(s))&&(tfont24[k].Index[1]==*(s+1)))
        { 
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<4;j++)
                {
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+0)))
                    {
                        DATA=0xf0;
                    }
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+1)))
                    {
                        DATA|=0x0f;
                    }
                    if(mode)
                    {
                        OLED_WR_DATA8(~DATA);
                    }
                    else
                    {
                        OLED_WR_DATA8(DATA);
                    }
                    DATA=0;
                }
            }
        }
    continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}

/**
 * @brief       OLEDʾ32ź
 * @param       x:еʼַ
 * @param       y:еʼַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowChinese32x32(uint16_t x,uint16_t y,uint8_t *s,uint16_t sizey,uint8_t mode)
{
    uint8_t i,j,k,DATA=0,HZnum;
    uint8_t TypefaceNum;
    x/=2;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;//ַռֽ
    HZnum=sizeof(tfont32)/sizeof(typFNT_GB32);	//ͳƺֿĿ
    Column_Address(x,x+sizey/2-1);
    Row_Address(y,y+sizey-1);
    for(k=0;k<HZnum;k++)
    {
        if ((tfont32[k].Index[0]==*(s))&&(tfont32[k].Index[1]==*(s+1)))
        {
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<4;j++)
                {
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+0)))
                    {
                        DATA=0xf0;
                    }
                    if(tfont16[k].Msk[i]&(0x01<<(j*2+1)))
                    {
                        DATA|=0x0f;
                    }
                    if(mode)
                    {
                        OLED_WR_DATA8(~DATA);
                    }
                    else
                    {
                        OLED_WR_DATA8(DATA);
                    }
                    DATA=0;
                }
            }
        }
    continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}


/**
 * @brief       OLEDʾַ
 * @param       x:ַеʼַ
 * @param       y:ַеʼַ
 * @param       chr:Ҫʾַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowChar(uint16_t x,uint16_t y,uint8_t chr,uint16_t sizey,uint8_t mode)
{
    uint8_t i,j,c,t=4,m,temp,DATA=0;
    uint8_t num;
    x/=2;
    c=chr-' ';
    num=(sizey/16+((sizey%16)?1:0))*sizey;
    Column_Address(x,x+sizey/4-1);
    Row_Address(y,y+sizey-1);
    for(i=0;i<num;i++)
    {
        if(sizey==16)temp=ascii_1608[c][i];//8x16ַ
        else if(sizey==24)temp=ascii_2412[c][i];//12x24ַ
        else if(sizey==32)temp=ascii_3216[c][i];//16x32ַ
        //else if(sizey==48)temp=ascii_4824[c][i];//24x48ַ
        else return;
        if(sizey%16)
        {
            m=sizey/16+1;
            if(i%m) 
            {
                t=2;
            }
            else 
            {
                t=4;
            }
        }
        for(j=0;j<t;j++)
        {
            if(temp&(0x01<<(j*2+0)))
            {
                DATA=0xf0;
            }
            if(temp&(0x01<<(j*2+1)))
            {
                DATA|=0x0f;
            }
            if(mode)
            {
                OLED_WR_DATA8(~DATA);
            }
            else
            {
                OLED_WR_DATA8(DATA);
            }
            DATA=0;
        }
    }
}

/**
 * @brief       OLEDʾַ
 * @param       x:ַеʼַ
 * @param       y:ַеʼַ
 * @param       *dp:Ҫʾַ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowString(uint16_t x,uint16_t y,uint8_t *dp,uint16_t sizey,uint8_t mode)
{
    while(*dp!='\0')
    {
        OLED_ShowChar(x,y,*dp,sizey,mode);
        dp++;
        x+=sizey/2;
    }
}

/**
 * @brief       
 * @param       m:
 * @param       n:ָ
 * @retval      result:mn
 */
//******************************************************************************
//    ˵m^n
//    ݣm: n:ָ
//    ֵ  result
//******************************************************************************
uint32_t oled_pow(uint8_t m,uint8_t n)
{
    uint32_t result=1;
    while(n--)
    {
        result*=m;
    }
    return result;
}

/**
 * @brief       OLEDʾ
 * @param       x:еʼַ
 * @param       y:еʼַ
 * @param       num:Ҫʾıֵ
 * @param       len:Ҫʾıֵλ
 * @param       sizey:ֺŴС
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_ShowNum(uint16_t x,uint16_t y,uint32_t num,uint8_t len,uint16_t sizey,uint8_t mode)
{
    uint8_t t,temp;
    uint8_t enshow=0;
    for(t=0;t<len;t++)
    {
        temp=(num/oled_pow(10,len-t-1))%10;
        if(enshow==0&&t<(len-1))
        {
            if(temp==0)
            {
                OLED_ShowChar(x+(sizey/2)*t,y,' ',sizey,mode);
                continue;
            }
            else
            {
                enshow=1;
            }

        }
        OLED_ShowChar(x+(sizey/2)*t,y,temp+'0',sizey,mode); 
    }
}

/**
 * @brief       OLEDʾ16ͼƬ
 * @param       x:ͼƬʼַ
 * @param       y:ͼƬʼַ
 * @param       length:ͼƬ
 * @param       width:ͼƬ߶
 * @param       BMP[]:ͼƬʾ
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_DrawBMP(uint16_t x,uint16_t y,uint16_t length,uint16_t width,const uint8_t BMP[],uint8_t mode)
{
    uint16_t i,num;
    length=(length/2+((length%2)?1:0))*2;
    num=length/2*width;
    x/=2;
    length/=2;
    Column_Address(x,x+length-1);
    Row_Address(y,y+width-1);
    for(i=0;i<num;i++)
    {
        if(mode)
        {
            OLED_WR_DATA8(~BMP[i]);
        }
        else
        {
            OLED_WR_DATA8(BMP[i]);
        }
    }
}

/**
 * @brief       OLEDʾɫͼƬ
 * @param       x:ͼƬʼַ
 * @param       y:ͼƬʼַ
 * @param       length:ͼƬ
 * @param       width:ͼƬ߶
 * @param       BMP[]:ͼƬʾ
 * @param       mode:Ƿɫʾ
 * @retval      
 */
void OLED_DrawSingleBMP(uint16_t x,uint16_t y,uint16_t length,uint16_t width,const uint8_t BMP[],uint8_t mode)
{
    uint8_t k,DATA=0;
    uint16_t i,num;
    length=(length/8+((length%8)?1:0))*8;
    num=length*width/8;
    x/=2;
    length/=2;
    Column_Address(x,x+length-1);
    Row_Address(y,y+width-1);
    for(i=0;i<num;i++)
    {
        for(k=0;k<4;k++)
        {
            if(BMP[i]&(0x01<<(k*2+0)))
            {
                DATA=0xf0;
            }
            if(BMP[i]&(0x01<<(k*2+1)))
            {
                DATA|=0x0f;
            }
            if(mode)
            {
                OLED_WR_DATA8(~DATA);
            }
            else
            {
                OLED_WR_DATA8(DATA);
            }
            DATA=0;
        }
    }
}

/**
 * @brief       OLEDĳʼ
 * @param       
 * @retval      
 */
void OLED_Init(void)
{
    OLED_GPIOInit();
    OLED_RES_Set();
    delay_ms(20);
    OLED_RES_Clr();
    delay_ms(20);
    OLED_RES_Set();
    delay_ms(120);
    OLED_WR_REG(0xAE);  //Set Display Off 
    OLED_WR_REG(0x15);  // Set Column Address 
    OLED_WR_REG(0x00);
    OLED_WR_REG(0x4F);
    OLED_WR_REG(0x75);  // Set Row Address 
    OLED_WR_REG(0x00);
    OLED_WR_REG(0x3F);
    OLED_WR_REG(0x81);  // Set Contrast Control 
    OLED_WR_REG(0xB0);
    OLED_WR_REG(0xA0);  // Set Re-map
    if(USE_HORIZONTAL==0)
    {
        OLED_WR_REG(0xC1);
        x_offset=0;
    }
    else
    {
        OLED_WR_REG(0x50);
        x_offset=0x30;
    }
    OLED_WR_REG(0xA1);  // Set Display Start Line
    OLED_WR_REG(0x00);
    OLED_WR_REG(0xA2);  // Set Display Offset
    OLED_WR_REG(0x00);
    OLED_WR_REG(0xA3);  // Set Vertical Scroll Area
    OLED_WR_REG(0x00); 
    OLED_WR_REG(0x40);
    OLED_WR_REG(0xA4);  // Set Display Mode (Normal display)
    OLED_WR_REG(0xA8);  // Set MUX Ratio 
    OLED_WR_REG(0x3F);
    OLED_WR_REG(0xAB);  // Function Selection A
    OLED_WR_REG(0x01);  // Select external VDD
    OLED_WR_REG(0xAD);  // External /Internal IREF Selection
    OLED_WR_REG(0x8E);  // Select external IREF
    OLED_WR_REG(0xB1);  // Set Phase Length
    OLED_WR_REG(0x82);
    OLED_WR_REG(0xB3);  // Set Front Clock Divider/Oscillator Frequency
    OLED_WR_REG(0xA0);
    OLED_WR_REG(0xB6);  // Set Second precharge Period
    OLED_WR_REG(0x04);
    OLED_WR_REG(0xB9);  // Linear LUT
    OLED_WR_REG(0xBC);  // Set Pre-charge voltage 
    OLED_WR_REG(0x04);
    OLED_WR_REG(0xBD);  // Pre-charge voltage capacitor Selection
    OLED_WR_REG(0x01);
    OLED_WR_REG(0xBE);  // Set VCOMH 
    OLED_WR_REG(0x05);  // 0.82*VCC
    OLED_Fill(0,0,OLED_W,OLED_H,0x00);//clear screen
    OLED_WR_REG(0xAF);  // Set Display ON
    
}





